               DIMENSION YY(10), CKER(10)
               DATA CKER /1.39,14.3,8.57,0,0,0,0,0,0,0/
               R=6380
               H=36000
               SATLON=75
               XLAT=-46.4
               XLON=73.6
               IGDAY=176
               TGM=17.7
               R1=11.6
               ALON=-XLON
               CALL POSSOL (IGDAY, TGM, ALON, XLAT, ASOL, AZSL)
c
c  ASOL: solar zentith angle
c  AZSL: solar azimuth
c 
               RAD=3.1416/180.
               DLAT=XLAT
               CDLAT=COS(DLAT*RAD)
               SDLAT=SIN(DLAT*RAD)
               DLON=XLON-SATLON
               CDLON=COS(DLON*RAD)
               TDLON=TAN(DLON*RAD)
               IF (DLAT.NE.0) THEN
                       AZST=(ATAN(TDLON/SDLAT))/RAD   ! satellite azimuth
               ELSE
                      IF (DLON.LT.0) AZST=-90.
                      IF (DLON.GT.0) AZST=90.
                      IF (DLON.EQ.0) AZST=0
               ENDIF
               VV=180.-AZSL           
               RLAZ=ABS(AZST-VV)                  ! RELATIVE AZIMUTH
               CGAM=CDLAT*CDLON 
               GAMMA=ACOS(CGAM)
               GAMDEG=GAMMA/RAD
               XXX=R*R+(R+H)*(R+H)-2*R*(R+H)*CGAM
               XX=SQRT(XXX)
               CSATZ=(-(R+H)*(R+H)+R*R+XXX)/(2*R*XX)       
               SATZ=180.-ACOS(CSATZ)*180/3.1416   ! satellite zenith angle

C ------------------------------------------
C CALCULATING REFERENCE REFLECTANCE FOR CH.1
C ------------------------------------------
      ITKER=3
      CALL KERNEL (ITKER,NKER,YY,50.,50.,0.) 
      AREF=0
      DO IKER=1,NKER
          AREF=AREF+YY(IKER)*CKER(IKER)
      ENDDO 
      WRITE (*,1820) NKER, AREF
 1820 FORMAT ('NKER: ',I4,'   AREF: ',F7.2)
      WRITE (*,1830) (YY(IKER),IKER=1,NKER)
      WRITE (*,1830) (CKER(IKER),IKER=1,NKER)
 1830 FORMAT (5E11.3)

               CALL KERNEL (ITKER,NKER,YY,ASOL,SATZ,RLAZ) 

              RX1=0
              DO IKER=1,NKER
                   RX1=RX1+YY(IKER)*CKER(IKER)
              ENDDO 
              RY1=RX1-AREF
              RR1=R1-RY1
              IF (RR1.LE.0) THEN
                 RR1=0      
              ENDIF 
      WRITE (*,1000) XLAT,XLON,IGDAY,TGM,ASOL,AZSL,SATZ,AZST,RLAZ
 1000 FORMAT (2F7.1,I5,8F7.1) 
      WRITE (*,1010) R1,RX1,RY1,RR1
 1010 FORMAT (5F8.2)
      END
      INCLUDE 'possol.f'
      INCLUDE 'kernel.f'
      
