      SUBROUTINE KERNEL (ITKER,NKER,YY,SOLZA,SATZA,SSRA)
      DIMENSION YY(10)
      DOUBLE PRECISION CSCAN
      ITYPE=ITKER   ! SPECIFIES THE TYPE OF THE MDEL USED
      PI=3.14159265
      RAD=PI/180.
      CSLZA=COS(SOLZA*RAD)  ! cos of the solar zenith angle
      CSTZA=COS(SATZA*RAD)  ! cos of the satelliet zenith angle 
      SSLZA=SIN(SOLZA*RAD)  ! sin of the solar zenith angle
      SSTZA=SIN(SATZA*RAD)  ! sin of the satellite zenith angle
      CSSRA=COS(SSRA*RAD)   ! cos of the relative azimuth
      SSSRA=SIN(SSRA*RAD)   ! sin of the realtive azimuth
      CSCAN=CSLZA*CSTZA+SSLZA*SSTZA*CSSRA  ! cos of the phase angle)
      CCCAN=CSCAN
      DEXT=EXP(-0.1/CSTZA)
      IF (ITYPE.EQ.1) THEN
C ------------------------------
C SIMPLE SATELLITE ZENITH ANGLE MODEL
C ------------------------------
         NKER=2          
         YY(1)=1./CSTZA     
         YY(2)=1.
      ENDIF
      IF (ITYPE.EQ.2) THEN
C ----------------------
C  BEST BA'S MODEL
C -----------------------
         NKER=3 
         YY(1)=1./(CSLZA+CSTZA)
         YY(2)= SSTZA*SSLZA*CSSRA   
         YY(3)=1.
      ENDIF 
      IF (ITYPE.EQ.3) THEN
C ----------------------
C   ROUJEAN'S MODEL
C ----------------------
         NKER=3
         TSLZA=SSLZA/CSLZA
         TSTZA=SSTZA/CSTZA
         GG=TSLZA*TSLZA+TSTZA*TSTZA-2*TSLZA*TSTZA*CSSRA
         G=SQRT(GG)
         YY(1)=1./(2*PI)*((PI-SSRA*RAD)*CSSRA+SSSRA)*TSLZA*TSTZA
     *                 -1./PI*(TSLZA+TSTZA+G)
         SCAN=ACOS(CCCAN)
         SCAND=SCAN/RAD
         SSCAN=SIN(SCAN)
         YY(2)=4./(3.*PI)*(1./(CSTZA+CSLZA))
     *                *((PI/2.-SCAN)*CSCAN+SSCAN)-1/3.
         YY(3)=1. 
C         WRITE (*,1000) SOLZA,SATZA,SSRA,SCAND,YY(1),YY(2),YY(3),GG
 1000    FORMAT (7F8.2,E11.3)
      ENDIF
      IF (ITYPE.EQ.4) THEN
C -------------------------------
C   SHIBAYAMA AND WEIGAND'S MODEL
C -------------------------------
        NKER=4
        SSRA2=SSRA/2.
        SSSRA2=SIN(SSRA2*RAD)
        YY(1)=SSTZA/CSLZA
        YY(2)=SSSRA2*SSTZA
        YY(3)=SSTZA
        YY(4)=1
      ENDIF
      IF (ITYPE.EQ.5) THEN
C ----------------------
C   ROUJEAN'S MODEL (first kernel)
C ----------------------
         NKER=2
         TSLZA=SSLZA/CSLZA
         TSTZA=SSTZA/CSTZA
         GG=TSLZA*TSLZA+TSTZA*TSTZA-2*TSLZA*TSTZA*CSSRA
         G=SQRT(G)
         YY(1)=1./(2*PI)*((PI-SSRA*RAD)*CSSRA+SSSRA)*TSLZA*TSTZA
     *                 -1./PI*(TSLZA+TSTZA+G)
         YY(2)=1. 
C         WRITE (*,1000) SOLZA,SATZA,SSRA,SCAND
C 1000    FORMAT (4F8.2)
      ENDIF
      IF (ITYPE.EQ.6) THEN
c ------------------------
c  separate azimuth and zenith model (for 3.9 micron)
c --------------------------
        NKER=3
         YY(1)=CSSRA
         YY(2)=1./(CSLZA+CSTZA)
         YY(3)=1.
      ENDIF
      IF (ITYPE.EQ.7) THEN
c ------------------------
c  azimuth ONLY MODEL  (for 3.9 micron)
c --------------------------
        NKER=2
         YY(1)=CSSRA
         YY(2)=1.
      ENDIF
      RETURN
      END
