c      common /SLT/ sollat
c      jday=80
c      tu=12
c      xlon=-20
c      xlat=40
c      call possol (jday,tu,xlon,xlat,asol,phis)
c      write (*,1000) jday,tu,xlon,xlat,sollat,asol, phis
c 1000 format (i3, 6f8.3)
c      end
      SUBROUTINE possol (jday,tu,xlon,xlat,asol,phis)
      COMMON /SLT/ sollat
C
C solar position (zenithal angle asol, azimuthal angle phi
C in degrees
C jday is the number of the day in the month
C tu is GMT time
C 
      pi = 3.1415926
      fac = pi/180.
C
C
C mean solar time
C
    3 tsm = tu + xlon/15.
      xlo = xlon*fac
      xla = xlat*fac
      xj = float(jday)
C
C time equation ( mn.dec)
C
      a1 = (1.00554*xj-6.28306)*fac
      a2 = (1.93946*xj+23.35089)*fac
      et = -7.67825*sin(a1) - 10.09176*sin(a2)
C
C true solar time
C
      tsv = tsm + et/60.
      tsv = (tsv-12.)
C
C hour angle
C
      ah = tsv*15.*fac
C
C solar declination (in radian)
C
      a3 = (0.9683*xj-78.00878)*fac
      delta = 23.4856*sin(a3)*fac
      sollat=delta/fac
C
C elevation, azimuth
C
      amuzero = sin(xla)*sin(delta)+cos(xla)*cos(delta)*cos(ah)
      elev=asin(amuzero)
      az = cos(delta)*sin(ah)/cos(elev)
      caz=(-cos(xla)*sin(delta)+sin(xla)*cos(delta)*cos(ah))/cos(elev)
C
      IF(az.ge.1.) THEN
        azim = asin(1.)
        GOTO 10
      ENDIF
C
      IF(az.le.-1.) THEN
        azim = asin(-1.)
        GOTO 10
      ENDIF
C
      azim=asin(az)
C
   10 IF(caz.le.0.) azim = pi - azim
      IF(caz.gt.0..and.az.le.0.) azim =2*pi+azim
      azim = azim + pi
      pi2 = 2*pi
      IF(azim.gt.pi2) azim = azim - pi2
      elev = elev*180./pi
C
C conversion in degrees
C
      asol = 90.-elev
      phis = azim/fac
      RETURN
      END
